## erlang 24.2.1+dfsg

=== lib/debugger/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 1997-2016. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#

#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Common Macros
# ----------------------------------------------------

SUB_DIRECTORIES = src priv doc/src

SPECIAL_TARGETS = 

# ----------------------------------------------------
# Default Subdir Targets
# ----------------------------------------------------
include $(ERL_TOP)/make/otp_subdir.mk

DIA_PLT_APPS=wx

include $(ERL_TOP)/make/app_targets.mk

=== lib/diameter/Makefile ===
#
# %CopyrightBegin%
#
# Copyright Ericsson AB 2010-2016. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# %CopyrightEnd%

include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk
include vsn.mk
include subdirs.mk

SUB_DIRECTORIES = $(SUB_DIRS) doc/src
SPECIAL_TARGETS =

include $(ERL_TOP)/make/otp_subdir.mk

DIA_PLT_APPS=ssl runtime_tools syntax_tools

include $(ERL_TOP)/make/app_targets.mk

=== lib/et/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 2002-2016. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#

#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Common Macros
# ----------------------------------------------------

include subdirs.mk

SPECIAL_TARGETS = 

# ----------------------------------------------------
# Default Subdir Targets
# ----------------------------------------------------
include $(ERL_TOP)/make/otp_subdir.mk

DIA_PLT_APPS=runtime_tools wx

include $(ERL_TOP)/make/app_targets.mk

=== lib/mnesia/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 1996-2021. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#

#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Macros
# ----------------------------------------------------

SUB_DIRECTORIES = src include examples doc/src

include vsn.mk
VSN = $(MNESIA_VSN)

SPECIAL_TARGETS = 

# ----------------------------------------------------
# Default Subdir Targets
# ----------------------------------------------------
include $(ERL_TOP)/make/otp_subdir.mk

include $(ERL_TOP)/make/app_targets.mk

=== lib/runtime_tools/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 1999-2016. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

#
# Macros
#

SUB_DIRECTORIES = src c_src doc/src

include vsn.mk
VSN = $(RUNTIME_TOOLS_VSN)

SPECIAL_TARGETS = 

#
# Default Subdir Targets
#
include $(ERL_TOP)/make/otp_subdir.mk

DIA_PLT_APPS=mnesia

include $(ERL_TOP)/make/app_targets.mk

=== lib/sasl/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 1996-2021. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

#
# Macros
#

SUB_DIRECTORIES = src doc/src examples/src

include vsn.mk
VSN = $(SASL_VSN)

SPECIAL_TARGETS = 

#
# Default Subdir Targets
#
include $(ERL_TOP)/make/otp_subdir.mk

DIA_PLT_APPS=tools

include $(ERL_TOP)/make/app_targets.mk

=== lib/ssl/Makefile ===
#
# %CopyrightBegin%
#
# Copyright Ericsson AB 1999-2021. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# %CopyrightEnd%
#

#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

#
# Macros
#

SUB_DIRECTORIES = src  doc/src examples/certs examples/src

include vsn.mk
VSN = $(SSL_VSN)

SPECIAL_TARGETS = 

#
# Default Subdir Targets
#
include $(ERL_TOP)/make/otp_subdir.mk

DIA_PLT_APPS=crypto runtime_tools inets public_key

include $(ERL_TOP)/make/app_targets.mk

=== lib/tools/Makefile ===
#
# %CopyrightBegin%
# 
# Copyright Ericsson AB 1996-2021. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Macros
# ----------------------------------------------------

SUB_DIRECTORIES = c_src src doc/src examples emacs

include vsn.mk
VSN = $(TOOLS_VSN)

SPECIAL_TARGETS = 

# ----------------------------------------------------
# Default Subdir Targets
# ----------------------------------------------------
include $(ERL_TOP)/make/otp_subdir.mk

DIA_PLT_APPS=compiler runtime_tools

include $(ERL_TOP)/make/app_targets.mk

=== erts/doc/src/Makefile ===
#
# %CopyrightBegin%
#
# Copyright Ericsson AB 1997-2021. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# %CopyrightEnd%
#

SPECS_ESRC = ../../preloaded/src/

include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Application version
# ----------------------------------------------------
include ../../vsn.mk
APPLICATION=erts
# ----------------------------------------------------
# Release directory specification
# ----------------------------------------------------
RELSYSDIR = $(RELEASE_PATH)/$(APPLICATION)-$(VSN)

# ----------------------------------------------------
# Target Specs
# ----------------------------------------------------
XML_APPLICATION_FILES = ref_man.xml
XML_REF1_FILES = epmd_cmd.xml \
	erl_cmd.xml \
	erlc_cmd.xml \
	escript_cmd.xml \
	werl_cmd.xml \
	erlsrv_cmd.xml \
	start_erl_cmd.xml \
	run_erl_cmd.xml \
	start_cmd.xml

XML_REF3_EFILES = \
	erl_prim_loader.xml \
	erlang.xml \
	erl_tracer.xml \
	init.xml \
	persistent_term.xml \
	atomics.xml \
	counters.xml \
	zlib.xml

XML_REF3_CREF = \
	driver_entry.xml \
	erl_nif.xml \
	erl_driver.xml \
	erts_alloc.xml

XML_REF3_FILES = \
	$(XML_REF3_EFILES) \
	$(XML_REF3_CREF)

XML_PART_FILES = \
	part.xml internal.xml

XML_INTERNAL_FILES = \
	CarrierMigration.xml	\
	ThreadProgress.xml	\
	CodeLoading.xml		\
	Tracing.xml		\
	DelayedDealloc.xml	\
	beam_makeops.xml	\
	GarbageCollection.xml	\
	PTables.xml		\
	PortSignals.xml		\
	ProcessManagementOptimizations.xml \
	SuperCarrier.xml        \
	CountingInstructions.xml\
	BeamAsm.xml

XML_CHAPTER_FILES = \
	introduction.xml \
	tty.xml \
	match_spec.xml \
	crash_dump.xml \
	alt_dist.xml \
	alt_disco.xml \
	driver.xml \
	absform.xml \
	inet_cfg.xml \
	erl_ext_dist.xml \
	erl_dist_protocol.xml \
	communication.xml \
	time_correction.xml \
	notes.xml

TOPDOCDIR=../../../doc

BOOK_FILES = book.xml

IMAGE_FILES = \
	erl_ext_fig.gif

XML_FILES = \
	$(BOOK_FILES) $(XML_CHAPTER_FILES) \
	$(XML_PART_FILES) $(XML_REF3_FILES) $(XML_REF1_FILES) $(XML_APPLICATION_FILES)

HTML_EXTRA_FILES = $(ERL_TOP)/erts/example/time_compat.erl \
	$(ERL_TOP)/lib/kernel/examples/gen_tcp_dist/src/gen_tcp_dist.erl \
	$(ERL_TOP)/lib/kernel/examples/erl_uds_dist/src/erl_uds_dist.erl

XML_GEN_FILES = $(XML_INTERNAL_FILES:%=$(XMLDIR)/%)

NO_CHUNKS = $(XML_REF3_CREF) erl_tracer.xml

# ----------------------------------------------------

INFO_FILE_SRC = ../../info.src

TOP_SPECS_FILE = specs.xml

XML_FIGURE_DIR = $(XMLDIR)/figures

INTERNAL_DOC_FIGURES = $(wildcard ../../emulator/internal_doc/figures/*.png) $(wildcard ../../emulator/internal_doc/figures/*.svg)
FIGURES = $(notdir $(INTERNAL_DOC_FIGURES))
XMLDIR_FIGURES = $(FIGURES:%=$(XML_FIGURE_DIR)/%)

# ----------------------------------------------------
# Targets
# ----------------------------------------------------
include $(ERL_TOP)/make/doc.mk

_create_dirs := $(shell mkdir -p $(XML_FIGURE_DIR))

$(XML_FIGURE_DIR)/%: ../../emulator/internal_doc/figures/%
	$(INSTALL_DATA) $< $@

html: figures

$(INFO_FILE): $(INFO_FILE_SRC) $(ERL_TOP)/make/$(TARGET)/otp.mk
	sed -e 's;%RELEASE%;$(SYSTEM_VSN);' $(INFO_FILE_SRC) > $(INFO_FILE)

figures: $(XMLDIR_FIGURES)

## This rule generate dummy specs for all XML_REF3_CREF's
$(XML_REF3_CREF:%.xml=$(SPECDIR)/specs_%.xml): $(@:%.xml=%.xml)
	$(gen_verbose)escript $(SPECS_EXTRACTOR) $(SPECS_FLAGS) \
                -o$(dir $@) -module $(patsubst $(SPECDIR)/specs_%.xml,%,$@)

$(XMLDIR)/%.xml: ../../emulator/internal_doc/%.md $(ERL_TOP)/make/emd2exml
	$(ERL_TOP)/make/emd2exml $< $@


# ----------------------------------------------------
# Release Target
# ----------------------------------------------------

release_html_spec: html release_figures

release_figures:
	$(INSTALL_DIR) "$(RELSYSDIR)/doc/html/figures"
	$(INSTALL_DATA) $(XMLDIR)/figures/* \
		"$(RELSYSDIR)/doc/html/figures"

=== erts/etc/unix/Makefile ===
#
# %CopyrightBegin%
#
# Copyright Ericsson AB 2013-2020. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# %CopyrightEnd%
#

include $(ERL_TOP)/make/output.mk
include $(ERL_TOP)/make/target.mk

include $(ERL_TOP)/make/$(TARGET)/otp.mk
include ../../vsn.mk

opt debug lcnt: etc

.PHONY: etc
etc: etp-commands

etp-commands: etp-commands.in
	$(gen_verbose)sed \
	-e 's:@ERL_TOP@:${ERL_TOP}:g' \
	-e 's:@TARGET@:${TARGET}:g' \
	etp-commands.in > etp-commands

.PHONY: docs
docs:

.PHONY: clean
clean:

# ----------------------------------------------------
# Release Target
# ---------------------------------------------------- 
include $(ERL_TOP)/make/otp_release_targets.mk

.PHONY: release_spec
release_spec: etc

=== erts/preloaded/src/Makefile ===
# 
# %CopyrightBegin%
# 
# Copyright Ericsson AB 2008-2021. All Rights Reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# %CopyrightEnd%
# 
# Note, this makefile is not called during normal build process, it should
# be used when the preloaded modules actually are to be updated (i.e. the 
# beam files are to be recompiled, which is normally not done). 
# The beam files are placed in the current directory and should be copied 
# to the ../ebin directory by using the copy target.

include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

EBIN=.

STATIC_EBIN=../ebin

include $(ERL_TOP)/erts/vsn.mk
include $(ERL_TOP)/lib/kernel/vsn.mk

ifeq ($(USE_ESOCK), yes)
PRE_LOADED_ERL_ESOCK_MODULES = \
	socket_registry \
	prim_socket \
	prim_net
else
PRE_LOADED_ERL_ESOCK_MODULES =
endif

PRE_LOADED_ERL_MODULES = \
	erl_prim_loader \
	init \
	prim_buffer \
	prim_file \
	prim_inet \
	$(PRE_LOADED_ERL_ESOCK_MODULES) \
	zlib \
	prim_zip \
	erl_init \
	erts_code_purger \
	erlang \
	erts_internal \
	erl_tracer \
	erts_literal_area_collector \
	erts_dirty_process_signal_handler \
	atomics \
	counters \
        persistent_term

PRE_LOADED_BEAM_MODULES = \
	prim_eval

PRE_LOADED_MODULES = $(PRE_LOADED_ERL_MODULES) $(PRE_LOADED_BEAM_MODULES)

RELSYSDIR = $(RELEASE_PATH)/lib/erts-$(VSN)
# not $(RELEASE_PATH)/erts-$(VSN)/preloaded

ERL_FILES= $(PRE_LOADED_ERL_MODULES:%=%.erl)
BEAM_FILES= $(PRE_LOADED_BEAM_MODULES:%=%.S)
STUBS_FILES= $(PRE_LOADED_BEAM_MODULES:%=%.erl)

TARGET_FILES = $(PRE_LOADED_MODULES:%=$(EBIN)/%.$(EMULATOR)) \
    $(APP_TARGET)
STATIC_TARGET_FILES = $(PRE_LOADED_MODULES:%=$(STATIC_EBIN)/%.$(EMULATOR))

APP_FILE= erts.app
APP_SRC= $(APP_FILE).src
APP_TARGET= $(STATIC_EBIN)/$(APP_FILE)
ifeq ($(USE_ESOCK), yes)
APP_ESOCK_MODS= prim_net, prim_socket, socket_registry,
else
APP_ESOCK_MODS=
endif


KERNEL_SRC=$(ERL_TOP)/lib/kernel/src
KERNEL_INCLUDE=$(ERL_TOP)/lib/kernel/include
STDLIB_INCLUDE=$(ERL_TOP)/lib/stdlib/include

ERL_COMPILE_FLAGS += +debug_info -I$(KERNEL_SRC) -I$(KERNEL_INCLUDE)

DIA_PLT      = erts-preloaded.plt
DIA_ANALYSIS = $(basename $(DIA_PLT)).dialyzer_analysis
ifeq ($(DIAW_EH),true)
DIA_WARNINGS += -Werror_handling
endif
ifeq ($(DIAW_US),true)
DIA_WARNINGS += -Wunderspecs
endif
ifeq ($(DIAW_UR),true)
DIA_WARNINGS += -Wunmatched_returns
endif


debug opt: $(TARGET_FILES) 

clean:
	rm -f $(TARGET_FILES)

copy:
	cp *.beam $(STATIC_EBIN)

$(APP_TARGET): $(APP_SRC) $(ERL_TOP)/erts/vsn.mk
	$(vsn_verbose)sed -e 's;%VSN%;$(VSN);' -e 's;%ESOCK_MODS%;$(APP_ESOCK_MODS);' $< > $@

include $(ERL_TOP)/make/otp_release_targets.mk

release_spec: $(APP_TARGET)
	$(INSTALL_DIR) "$(RELSYSDIR)/src"
	$(INSTALL_DATA) $(ERL_FILES) $(BEAM_FILES) $(STUBS_FILES) "$(RELSYSDIR)/src"
	$(INSTALL_DIR) "$(RELSYSDIR)/ebin"
	$(INSTALL_DATA) $(STATIC_TARGET_FILES) $(APP_TARGET) "$(RELSYSDIR)/ebin"

release_docs_spec:


list_preloaded:
	@echo $(PRE_LOADED_MODULES)

dclean:
	rm -f $(DIA_PLT)
	rm -f $(DIA_ANALYSIS)

dialyzer_plt: $(DIA_PLT)

$(DIA_PLT): $(ERL_FILES)
	@echo "Building ($(basename $(DIA_PLT))) plt file"
	@dialyzer --build_plt \
                  --output_plt $@ \
                  -r ../ebin \
                     ../../../lib/kernel/ebin \
                     ../../../lib/stdlib/ebin \
                     ../../../lib/crypto/ebin \
                     ../../../lib/compiler/ebin \
                  --output $(DIA_ANALYSIS) \
                  --verbose

dialyzer: $(DIA_PLT)
	@echo "Running dialyzer on $(basename $(DIA_PLT))"
	@dialyzer --plt $< \
                  ../ebin \
                  $(DIA_WARNINGS) \
                  --verbose

#
# Combine a BEAM assembly script file a stub Erlang file into a BEAM file.
# See add_abstract_chunk script.
#

prim_eval.abstr: prim_eval.erl
	$(V_ERLC) $(ERL_COMPILE_FLAGS) -o$(dir $@) +dabstr $<

prim_eval.beam: prim_eval.S prim_eval.abstr
	$(gen_verbose)
	$(V_at)$(ERLC) $(ERL_COMPILE_FLAGS) $<
	$(V_at)escript add_abstract_code $@ prim_eval.abstr || (rm $@; exit 1)

# Include dependencies -- list below added by PaN
$(EBIN)/erl_prim_loader.beam: $(KERNEL_SRC)/inet_boot.hrl $(KERNEL_INCLUDE)/file.hrl
$(EBIN)/prim_file.beam: $(KERNEL_SRC)/file_int.hrl $(KERNEL_INCLUDE)/file.hrl
$(EBIN)/prim_inet.beam: $(KERNEL_SRC)/inet_int.hrl $(KERNEL_INCLUDE)/inet_sctp.hrl
$(EBIN)/prim_zip.beam: zip_internal.hrl $(KERNEL_INCLUDE)/file.hrl $(STDLIB_INCLUDE)/zip.hrl
$(EBIN)/init.erl: $(KERNEL_INCLUDE)/file.hrl

=== lib/asn1/test/Makefile ===
#
# %CopyrightBegin%
#
# Copyright Ericsson AB 1997-2020. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# %CopyrightEnd%
#
#
include $(ERL_TOP)/make/target.mk
include $(ERL_TOP)/make/$(TARGET)/otp.mk

# ----------------------------------------------------
# Target Specs
# ----------------------------------------------------

MODULES= \
	h323test \
	ber_decode_error \
	testPrim \
	testPrimStrings \
	testCompactBitString \
	testPrimExternal \
	testChoPrim \
	testChoExtension \
	testChoExternal \
	testChoOptional \
	testChoRecursive \
	testChoTypeRefCho \
	testChoTypeRefPrim \
	testChoTypeRefSeq \
	testChoTypeRefSet \
	testConstraints \
	testDef \
	testExtensionDefault \
	testOpt \
	testSeqDefault \
	testSeqExtension \
	testSeqExternal \
	testSeqOptional \
	testSeq2738 \
	testSeqPrim \
	testSeqSetIndefinite \
	testSeqTag \
	testSeqTypeRefCho \
	testSeqTypeRefPrim \
	testSeqTypeRefSeq \
	testSeqTypeRefSet \
	testSeqOf \
	testSeqOfIndefinite \
	testSeqOfCho \
	testSeqOfChoExt \
	testSeqOfExternal \
	testSeqOfTag \
	testSetDefault \
	testSetExtension \
	testSetExternal \
	testSetOptional \
	testSetPrim \
	testSetTag \
	testSetTypeRefCho \
	testSetTypeRefPrim \
	testSetTypeRefSeq \
	testSetTypeRefSet \
	testDefaultOctetString \
	testChoiceIndefinite \
	testSetOf \
	testSetOfCho \
	testSetOfExternal \
	testSetOfTag \
	testEnumExt \
	testInfObjectClass \
	testInfObj \
	testInfObjExtract \
	testParameterizedInfObj \
	testFragmented \
	testMaps \
	testMergeCompile \
	testMultipleLevels \
	testDeepTConstr \
	testTimer \
	testMegaco \
	testSeqSetDefaultVal \
	testParamBasic \
	testContextSwitchingTypes \
	testTypeValueNotation \
	testOpenTypeImplicitTag \
	testINSTANCE_OF \
	test_partial_incomplete_decode \
	testDER \
	test_selective_decode \
	test_special_decode_performance \
	testTCAP \
	testSSLspecs \
	testSelectionTypes \
	test_undecoded_rest \
	testTcapsystem \
	testNBAPsystem \
	test_compile_options \
	testDoubleEllipses \
	test_modified_x420 \
	test_x691 \
	testWSParamClass \
	testValueTest \
	testUniqueObjectSets \
	testRfcs \
	testImporting \
	testExtensibilityImplied \
	asn1_test_lib \
	asn1_app_SUITE \
	asn1_SUITE \
	error_SUITE \
	syntax_SUITE

ERL_FILES= $(MODULES:%=%.erl)

HRL_FILES= External.hrl

EMAKEFILE=Emakefile

# ----------------------------------------------------
# Release directory specification
# ----------------------------------------------------
RELSYSDIR = $(RELEASE_PATH)/asn1_test

# ----------------------------------------------------
# FLAGS
# ----------------------------------------------------
ERL_COMPILE_FLAGS += +warnings_as_errors +nowarn_export_all
EBIN = .

# ----------------------------------------------------
# Targets
# ----------------------------------------------------

$(EMAKEFILE): $(ERL_FILES) $(HRL_FILES)
	$(ERL_TOP)/make/make_emakefile $(ERL_COMPILE_FLAGS) -o$(EBIN) $(MODULES) $(ERL_FILES) >$(EMAKEFILE)

tests debug opt: $(EMAKEFILE)

clean:
	rm -f core

docs:

# ----------------------------------------------------
# Release Target
# ---------------------------------------------------- 
include $(ERL_TOP)/make/otp_release_targets.mk

release_spec: opt

release_tests_spec: opt
	$(INSTALL_DIR) "$(RELSYSDIR)"
	$(INSTALL_DIR) "$(RELSYSDIR)/asn1_SUITE_data"
	$(INSTALL_DATA) $(EMAKEFILE) $(ERL_FILES) $(HRL_FILES) "$(RELSYSDIR)"
	$(INSTALL_DATA) asn1.spec asn1.cover $(INSTALL_PROGS) "$(RELSYSDIR)"
	chmod -R u+w "$(RELSYSDIR)"
	cd asn1_SUITE_data; tar cfh "$(RELSYSDIR)/asn1_SUITE_data.tar" *
	cd "$(RELSYSDIR)/asn1_SUITE_data"; tar xf "$(RELSYSDIR)/asn1_SUITE_data.tar"
	rm "$(RELSYSDIR)/asn1_SUITE_data.tar"

release_docs_spec:

=== debian/changelog ===
erlang (1:24.2.1+dfsg-1ubuntu0.6) jammy-security; urgency=medium

  * SECURITY UPDATE: Increased resource consumption in the SSH module.
    - debian/patches/CVE-2025-48038.patch: Add handle_op for file handle length
      string exceeding 256 bytes in lib/ssh/src/ssh_sftpd.erl.
    - debian/patches/CVE-2025-48039.patch: Add max_path option and limits in
      lib/ssh/src/ssh_sftpd.erl.i
    - debian/patches/CVE-2025-48040-pre1.patch: Fix error by adding try catch
      in lib/ssh/src/ssh_transport.erl.
    - debian/patches/CVE-2025-48040.patch: Add max_log_len in
      lib/ssh/src/ssh_connection.erl. Add Class:Reason0:Stacktrace for decode
      failures in lib/ssh/src/ssh_connection_handler.erl. Add trim_reason and
      max_log_len in lib/ssh/src/ssh_lib.erl. Change decode_kex_init in
      lib/ssh/src/ssh_message.erl. Change kexinit_error and modify Msg in
      lib/ssh/src/ssh_transport.erl.
    - debian/patches/CVE-2025-48041.patch: Add max_handles option and limits in
      lib/ssh/src/ssh_sftpd.erl.
    - CVE-2025-48038
    - CVE-2025-48039
    - CVE-2025-48040
    - CVE-2025-48041

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Fri, 17 Oct 2025 15:17:48 -0230

erlang (1:24.2.1+dfsg-1ubuntu0.5) jammy-security; urgency=medium

  * SECURITY UPDATE: insufficient strict KEX handshake hardening measures
    - debian/patches/CVE-2025-46712-pre1.patch: postpone
      ssh_connection_handler init in
      lib/ssh/src/ssh_connection_handler.erl.
    - debian/patches/CVE-2025-46712-pre2.patch: implement KEX strict in
      lib/ssh/src/ssh.hrl, lib/ssh/src/ssh_connection_handler.erl,
      lib/ssh/src/ssh_fsm_kexinit.erl, lib/ssh/src/ssh_transport.erl,
      lib/ssh/src/ssh_transport.hrl, lib/ssh/test/ssh_protocol_SUITE.erl,
      lib/ssh/test/ssh_test_lib.erl, lib/ssh/test/ssh_to_openssh_SUITE.erl,
      lib/ssh/test/ssh_trpt_test_lib.erl.
    - debian/patches/CVE-2025-46712-1.patch: add KEX strict implementation
      fixes in lib/ssh/src/ssh_connection_handler.erl,
      lib/ssh/src/ssh_fsm_kexinit.erl, lib/ssh/src/ssh_transport.erl,
      lib/ssh/test/ssh_protocol_SUITE.erl,
      lib/ssh/test/ssh_trpt_test_lib.erl.
    - CVE-2025-46712
  * SECURITY UPDATE: path traversal and other issues in zip
    - debian/patches/CVE-2025-4748.patch: properly sanitize filenames when
      (un)zipping in lib/stdlib/src/zip.erl, lib/stdlib/test/zip_SUITE.erl.
    - CVE-2025-4748

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 10 Jul 2025 12:45:03 -0400

erlang (1:24.2.1+dfsg-1ubuntu0.4) jammy-security; urgency=medium

  * SECURITY UPDATE: Unauthenticated Remote Code Execution in SSH
    - debian/patches/CVE-2025-32433.patch: disconnect when connection
      protocol message arrives when user is not authenticated for
      connection in lib/ssh/src/ssh_connection.erl,
      lib/ssh/test/ssh_protocol_SUITE.erl.
    - CVE-2025-32433

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 16 Apr 2025 14:23:11 -0400

erlang (1:24.2.1+dfsg-1ubuntu0.3) jammy-security; urgency=medium

  * SECURITY UPDATE: denial of service
    - debian/patches/CVE-2025-30211-pre1.patch: reduce log length.
    - debian/patches/CVE-2025-30211-1.patch: reduce log processing for
      plain connections.
    - debian/patches/CVE-2025-30211-2.patch: ignore too long names.
    - debian/patches/CVE-2025-30211-3.patch: use chars_limit for bad
      packets error messages.
    - debian/patches/CVE-2025-30211-4.patch: custom_kexinit test added.
    - CVE-2025-30211

 -- Fabian Toepfer <fabian.toepfer@canonical.com>  Wed, 02 Apr 2025 19:28:13 +0200

erlang (1:24.2.1+dfsg-1ubuntu0.2) jammy-security; urgency=medium

  * SECURITY UPDATE: incorrect SSH packet size check
    - debian/patches/CVE-2025-26618.patch: sftp reject packets exceeding
      limit in lib/ssh/src/ssh_sftpd.erl.
    - CVE-2025-26618

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 27 Feb 2025 10:52:11 -0500

erlang (1:24.2.1+dfsg-1ubuntu0.1) jammy-security; urgency=medium

  * SECURITY UPDATE: SSL, TLS and DTLS client authentication bypass
    - d/p/CVE-2022-37026-1.patch: fix handling of unexpected
      messages. Based on upstream patch.
    - d/p/CVE-2022-37026-2.patch: correct guard check. Based on upstream
      patch.
    - CVE-2022-37026  

 -- Alex Murray <alex.murray@canonical.com>  Wed, 26 Apr 2023 10:44:55 +0200

erlang (1:24.2.1+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 07 Feb 2022 10:48:20 +0300

erlang (1:24.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 15 Dec 2021 19:39:20 +0300

erlang (1:24.1.7+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 10 Dec 2021 12:51:44 +0300

erlang (1:24.1.5+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 17 Nov 2021 08:32:50 +0300

erlang (1:24.1.4+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 08 Nov 2021 17:19:55 +0300

erlang (1:24.1.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Remove an unused lintian override.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 01 Oct 2021 13:54:07 +0300

erlang (1:24.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Replace calls to 'which', which is deprecated, by calls to
    'command -v' in maintainer scripts.
  * Mark the erlang, erlang-doc, erlang-examples, erlang-nox, erlang-src,
    erlang-x11 packages as multi-arch foreign.
  * Move epmd.service and epmd.socket to /usr/lib/systemd/system/.
  * Bump standards version to 4.6.0.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 28 Sep 2021 10:15:57 +0300

erlang (1:24.0.6+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 04 Sep 2021 09:50:21 +0300



=== debian/control ===
Source: erlang
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Erlang Packagers <pkg-erlang-devel@lists.alioth.debian.org>
Uploaders: Sergei Golovan <sgolovan@debian.org>
Section: interpreters
Priority: optional
Standards-Version: 4.6.0
Build-Depends: debhelper (>= 10.0.0), autoconf (>= 2.71), openssl, libssl-dev, m4,
 libncurses5-dev, unixodbc-dev, bison, flex, ed, zlib1g-dev,
 libwxgtk3.0-gtk3-dev, libwxgtk-webview3.0-gtk3-dev, libx11-dev, dctrl-tools, xsltproc,
 libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev,
 libsctp-dev [linux-any], libsystemd-dev [linux-any], erlang-base:native <cross>
Build-Depends-Indep: libxml2-utils, fop, default-jdk | sun-java6-jdk
Build-Conflicts: autoconf2.13, libwxgtk2.4-dev, libwxgtk2.6-dev, libwxgtk2.8-dev
Homepage: http://www.erlang.org/
Vcs-Browser: https://salsa.debian.org/erlang-team/packages/erlang
Vcs-Git: https://salsa.debian.org/erlang-team/packages/erlang.git

Package: erlang-base
Architecture: any
Multi-Arch: allowed
Depends: procps, adduser, ${shlibs:Depends}, ${misc:Depends}
Recommends: ${libsctp:Version}, erlang-crypto (= ${binary:Version}), erlang-syntax-tools (= ${binary:Version})
Suggests: erlang-tools (= ${binary:Version}),  erlang, erlang-manpages, erlang-doc
Conflicts: erlang (<< ${source:Version}), erlang-base-hipe, erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2), erlang-doc-html (<< 1:13.b.4)
Replaces: erlang (<< ${source:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${source:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-typer (<< 1:20.0+dfsg), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2), erlang-doc-html (<< 1:13.b.4)
Provides: erlang-abi (= 17.0), erlang-pcre (= 8.44), erlang-abi-17.0
Breaks: rabbitmq-server (<< 3.7.7)
Description: Erlang/OTP virtual machine and base applications
 This package contains the Erlang/OTP runtime implementation,
 and minimal set of Erlang applications:
  compiler - compiles Erlang code to byte-code;
  erts - the Erlang runtime system application;
  kernel - code necessary to run the Erlang runtime system itself;
  ose - code for Enea OSE operating system;
  sasl - the system architecture support libraries application;
  stdlib - modules for manipulating lists, strings, files etc.


Package: erlang-asn1
Architecture: any
Multi-Arch: allowed
Depends: ${erlang-base}, ${shlibs:Depends}, ${misc:Depends}
Suggests: erlang, erlang-manpages, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP modules for ASN.1 support
 The Asn1 application contains modules with compile-time and run-time
 support for ASN.1 in Erlang/OTP.


Package: erlang-common-test
Architecture: any
Multi-Arch: allowed
Depends: ${erlang-base}, erlang-crypto (= ${binary:Version}), erlang-debugger (= ${binary:Version}), erlang-ftp (= ${binary:Version}), erlang-inets (= ${binary:Version}), erlang-observer (= ${binary:Version}), erlang-runtime-tools (= ${binary:Version}), erlang-snmp (= ${binary:Version}), erlang-ssh (= ${binary:Version}), erlang-syntax-tools (= ${binary:Version}), erlang-tools (= ${binary:Version}), erlang-xmerl (= ${binary:Version}), libjs-jquery, libjs-jquery-tablesorter, ${shlibs:Depends}, ${misc:Depends}
Suggests: erlang, erlang-manpages, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP application for automated testing
 Common Test is a portable application for automated testing. It is
 suitable for black-box testing of target systems of any type (i.e.
 not necessarily implemented in Erlang), as well as for white-box
 testing of Erlang/OTP programs. Black-box testing is performed via
 standard interfaces (such as SNMP, HTTP, Corba, Telnet, etc) and,
 if required, via user specific interfaces (often called test ports).
 White-box testing of Erlang/OTP programs is easily accomplished by
 calling the target API functions directly from the test case functions.
 Common Test also integrates usage of the OTP cover tool for code
 coverage analysis of Erlang/OTP programs.


Package: erlang-crypto
Architecture: any
Multi-Arch: allowed
Depends: ${erlang-base}, ${shlibs:Depends}, ${misc:Depends}
Suggests: erlang, erlang-manpages, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP cryptographic modules
 The Crypto Application provides functions for computation of message
 digests, encryption and decryption functions. It uses OpenSSL for
 actual calculations.


Package: erlang-debugger
Architecture: any
Multi-Arch: allowed
Depends: ${erlang-base}, erlang-wx (= ${binary:Version}), ${misc:Depends}
Suggests: erlang, erlang-manpages, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP application for debugging and testing
 Debugger is a graphical tool which can be used for debugging and
 testing of Erlang programs. For example, breakpoints can be set,
 code can be single stepped and variable values can be inspected
 and modified.


Package: erlang-dialyzer
Architecture: any
Multi-Arch: allowed
Depends: ${erlang-base}, erlang-syntax-tools (=${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: erlang-wx (= ${binary:Version}), erlang, erlang-manpages, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP discrepancy analyzer application
 Dialyzer is a static analysis tool that identifies software
 discrepancies such as type errors, unreachable code, unnecessary
 tests etc. in single Erlang modules or entire (sets of) applications.


Package: erlang-diameter
Architecture: any
Multi-Arch: allowed
Depends: ${erlang-base}, erlang-runtime-tools (= ${binary:Version}), erlang-ssl (= ${binary:Version}), erlang-syntax-tools (=${binary:Version}), ${misc:Depends}
Suggests: erlang, erlang-manpages, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP implementation of RFC 6733 protocol
 Interface with which a user creates a service that sends and receives
 messages using the Diameter protocol as defined in RFC 6733.


Package: erlang-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: erlang:any
Conflicts: erlang-doc-html, erlang-base:any (<< 1:13.b.4), erlang-base-hipe:any
Replaces: erlang-doc-html
Provides: erlang-doc-html
Description: Erlang/OTP HTML/PDF documentation
 Documentation for the Erlang programming language and OTP
 library in HTML and PDF formats.


Package: erlang-edoc
Architecture: any
Multi-Arch: allowed
Depends: ${erlang-base}, erlang-inets (= ${binary:Version}), erlang-syntax-tools (=${binary:Version}), erlang-xmerl (= ${binary:Version}), ${misc:Depends}
Suggests: erlang, erlang-manpages, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP module for generating documentation
 EDoc is the Erlang program documentation generator. Inspired by the
 Javadoc tool for the Java programming language, EDoc is adapted to
 the conventions of the Erlang world.


Package: erlang-eldap
Architecture: any
Multi-Arch: allowed
Depends: ${erlang-base}, erlang-asn1 (= ${binary:Version}), erlang-ssl (=${binary:Version}), ${misc:Depends}
Suggests: erlang, erlang-manpages, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP LDAP library
 Eldap is a module which provides a client API to the Lightweight
 Directory Access Protocol (LDAP).


Package: erlang-erl-docgen
Architecture: any
Multi-Arch: allowed
Depends: ${erlang-base}, erlang-edoc (= ${binary:Version}), erlang-xmerl (= ${binary:Version}), ${misc:Depends}
Suggests: xsltproc, fop, erlang, erlang-manpages, erlang-doc
Replaces: erlang (<< ${source:Version}), erlang-base (<< ${binary:Version}), erlang-base-hipe, erlang-nox (<< ${source:Version}), erlang-x11 (<< ${binary:Version}), erlang-src (<< ${source:Version}), erlang-dev (<< ${binary:Version}), erlang-examples (<< ${source:Version}), erlang-mode (<< 1:12.b.1-dfsg-2), erlang-doc (<< ${source:Upstream-Version}), erlang-doc (>> ${source:Upstream-Version}-999), erlang-manpages (<= 1:11.b.1-2)
Description: Erlang/OTP documentation stylesheets
 The erl_docgen package includes XSLT stylesheets and document type
 definitions used for Erlang/OTP documentation. They allow one to
 transform documentation to manpage, HTML, and PDF formats.


Package: erlang-et
Architecture: any
Multi-Arch: allowed
Depends: ${erlang-base}, erlang-runtime-tools (= ${binary:Version}), erlang-wx (= ${binary:Version}), ${misc:Depends}
Suggests: erlang, erlang-manpages, erlang-doc

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ROOT_DIR=$(shell pwd)
MAN_DIR = $(ROOT_DIR)/debian/erlang-docs/usr/lib/erlang/man

export HOME := $(ROOT_DIR)/debian

-include ${ROOT_DIR}/erts/vsn.mk
-include ${ROOT_DIR}/lib/diameter/vsn.mk
-include ${ROOT_DIR}/lib/erl_interface/vsn.mk
-include ${ROOT_DIR}/lib/jinterface/vsn.mk
-include ${ROOT_DIR}/lib/ic/vsn.mk
-include ${ROOT_DIR}/lib/tools/vsn.mk
-include ${ROOT_DIR}/lib/common_test/vsn.mk
-include ${ROOT_DIR}/lib/snmp/vsn.mk
SOURCE_VERSION=$(shell dpkg-parsechangelog | sed -ne's!^Version: \(.*\)-.*!\1!p')

PCRE_MAJOR=$(shell cat erts/emulator/pcre/pcre.h | grep PCRE_MAJOR | sed -e's/.*\s\([0-9]\+\).*/\1/')
PCRE_MINOR=$(shell cat erts/emulator/pcre/pcre.h | grep PCRE_MINOR | sed -e's/.*\s\([0-9]\+\).*/\1/')
PCRE_VERSION=$(PCRE_MAJOR).$(PCRE_MINOR)
ABI_VERSION=17.0

BINARY_TARGETS=binary-erlang-base
INSTALL_RULE=install-stnd-stamp
TMPINSTALL_DIR=debian/erlang-stnd
ERLANGBASE=erlang-base (= $${binary:Version})

USE_ESOCKET := $(shell echo ${DEB_HOST_ARCH} | egrep -c "hurd" | sed -es/1/no/ -es/0/yes/)
ifeq ($(USE_ESOCKET), no)
ESOCKET_OPT=--disable-esock
else
ESOCKET_OPT=--enable-esock
endif

USE_KERNEL_POLL := $(shell echo ${DEB_HOST_ARCH} | egrep -c "hurd" | sed -es/1/no/ -es/0/yes/)
ifeq ($(USE_KERNEL_POLL), no)
KERNEL_POLL_OPT=--disable-kernel-poll
else
KERNEL_POLL_OPT=--enable-kernel-poll
endif

USE_CLOCK_GETTIME := $(shell echo ${DEB_HOST_ARCH} | egrep -c "bsd|hurd" | sed -es/1/no/ -es/0/yes/)
ifeq ($(USE_CLOCK_GETTIME), no)
CLOCK_GETTIME_OPT=
SYSTEMD_OPT=
else
CLOCK_GETTIME_OPT=--enable-clock-gettime
SYSTEMD_OPT=--enable-systemd
endif

# Temporary (until #475459 is fixed) disabling threads for sparc architecture
ifeq ($(DEB_HOST_ARCH), sparc)
THREAD_OPTS=--disable-threads --disable-smp-support
else
THREAD_OPTS=--enable-threads --enable-smp-support
endif

LIBSCTP=$(shell grep-status -s Depends -PX libsctp-dev |sed -e 's!.*\(libsctp[0-9]*\).*!\1!')
LIBSCTPDEP=$(shell grep-status -s Version -PX $(LIBSCTP) | sed -e's!^Version: \(.*\)-[^-]*!$(LIBSCTP) (>= \1)!')

USE_SCTP := $(shell echo ${DEB_HOST_ARCH} | egrep -c "bsd|hurd" | sed -es/1/no/ -es/0/yes/)
ifeq ($(USE_SCTP), no)
SCTP_OPT=--disable-sctp
else
SCTP_OPT=--enable-sctp
endif

ifeq ($(findstring debug,$(DEB_BUILD_OPTIONS)),debug)
CFLAGS=-g -O2 -fno-strict-aliasing
GEN_OPT_FLGS=-O2 -fno-strict-aliasing
TYPE=debug
else
CFLAGS=-g -O2 -fno-strict-aliasing
GEN_OPT_FLGS=-O2 -fno-strict-aliasing
TYPE=
endif

JAVA_OPTIONS=-Xlint -source 1.8 -target 1.8

JOBS=4

debian/control: debian/control.in debian/rules
	sed -e's/@PCRE_VERSION@/$(PCRE_VERSION)/g' \
	    -e's/@ABI_VERSION@/$(ABI_VERSION)/g' <$< >$@

clean:
	dh_testdir
	dh_testroot
	#
	[ ! -f Makefile ] || ${MAKE} -j ${JOBS} clean
	rm -f lib/dialyzer/SKIP
	#
	# Remove installed erlang from debian/
	rm -rf debian/erlang-docs
	rm -rf debian/erlang-stnd
	#
	# Restore replaced configure, config.guess, and config.sub files
	for i in `find ${ROOT_DIR} -name 'configure.backup'` ; do \
	    mv $$i $${i%%.backup} ; \
	done
	for i in `find ${ROOT_DIR} -name 'config.guess~'` ; do \
	    mv $$i $${i%%\~} ; \
	done
	for i in `find ${ROOT_DIR} -name 'config.sub~'` ; do \
	    mv $$i $${i%%\~} ; \
	done
	rm -f lib/configure.in
	#
	# Remove files, which were generated from templates
	for i in debian/*.in debian/scripts/*.in ; do \
	    if [ "$$i" != "debian/control.in" ] ; then \
		rm -f $${i%%.in} ; \
	    fi ; \
	done
	#
	# *.install were also generated on-the-fly
	rm -f debian/*.install
	rm -f debian/erlang-doc.links
	rm -f debian/erlang-doc.doc-base.erlang-erts
	#
	rm -f debian/AUTHORS
	#
	# Remove touched stamp files
	rm -f *-stamp
	#
	dh_clean -Xtest.erl.orig

automake: automake-stamp
automake-stamp: debian/control
	dh_testdir
	#
	# Return error if there are known nonfree docs in upstream tarball
	# Return error if there are prebuilt binaries in upstream tarball
	err=0 ; \
	for fn in `find lib/*/doc -name standard -or -name archive` ; do \
	    err=1 ; \
	    echo Found directory $$fn with non-free docs in upstream. Please remove it. ; \
	done ; \
	if [ -f prebuilt.files ] ; then \
	    err=1 ; \
	    echo Found prebuilt binaries in upstream. Please remove them. ; \
	fi ; \
	if [ $$err = 1 ] ; then \
	    echo ; \
	    echo Use uscan --download to get the upstream tarball. ; \
	    echo ; \
	    false ; \
	fi
	#
	# Preserve configure scripts
	for i in `find ${ROOT_DIR} -not \( -wholename '*/.pc' -prune \) \
				    -a -name 'configure'` ; do \
	    cp -f $$i $$i.backup ; \
	done
	#
	# Replace config.guess and config.sub by installed in /usr/share/misc.
	# Also add suffix -gnu to ibm-linux in config.guess to fix FTBFS
	# on s390 architecture
	for i in `find ${ROOT_DIR} -not \( -wholename '*/.pc' -prune \) \
				    -a -name 'config.guess'` ; do \
	    cp -fb /usr/share/misc/config.guess $$i ; \
	    sed -i 's/-ibm-linux$$/-ibm-linux-gnu/g' $$i ; \
	done
	for i in `find ${ROOT_DIR} -not \( -wholename '*/.pc' -prune \) \
				    -a -name 'config.sub'` ; do \
	    cp -fb /usr/share/misc/config.sub $$i ; \
	done
	#
	# Regenerate configure scripts using autoconf
	./otp_build update_configure --no-commit
	#
	touch automake-stamp

configure-stnd: configure-stnd-stamp
configure-stnd-stamp: automake-stamp
	dh_testdir
	#
	echo "BUILDING STANDARD VERSION"
	#
	[ ! -f Makefile ] || ${MAKE} -j ${JOBS} clean
	rm -f lib/dialyzer/SKIP
	#
	CFLAGS="$(CFLAGS)" \
	./configure --host=$(DEB_HOST_GNU_TYPE) \
		    --build=$(DEB_BUILD_GNU_TYPE) \
		    --prefix=/usr \
		    --libexecdir=/usr/bin \
		    --infodir=/usr/share/info \
		    --mandir=/usr/share/man \
		    --enable-hybrid-heap \
		    $(THREAD_OPTS) \
		    $(KERNEL_POLL_OPT) \
		    $(ESOCKET_OPT) \
		    $(SYSTEMD_OPT) \
		    $(SCTP_OPT) \
		    $(CLOCK_GETTIME_OPT) \
		    --enable-dynamic-ssl-lib \
		    --with-ssl-rpath=no \
		    --enable-ethread-pre-pentium4-compatibility \
		    --enable-shared-zlib \
		    --disable-builtin-zlib \
		    --without-ssl-zlib \
		    --disable-silent-rules
	#
	touch configure-stnd-stamp

define do-install
	echo "*** do-install called for $(INSTALL_DIR)."

	# Calls make install.
	${MAKE} -j ${JOBS} DESTDIR=$(INSTALL_DIR) TYPE=$(TYPE) install

	# Replace ROOTDIR in "erl" and "start" scripts for real rootdir
	# If there's no erl or start then it's better to fail than silently continue
	for dir in $(INSTALL_DIR)/usr/lib/erlang/erts-$(VSN)/bin		\
		   $(INSTALL_DIR)/usr/lib/erlang/bin; do			\
	    for val in erl start; do						\
		sed -i 's!ROOTDIR=.*!ROOTDIR=/usr/lib/erlang!' $${dir}/$${val}; \
	    done;								\
	done

	# Correct ERL_ROOT in RELEASES file
	sed 's!%ERL_ROOT%!/usr/lib/erlang!' \
	    $(INSTALL_DIR)/usr/lib/erlang/releases/RELEASES.src \
	    >$(INSTALL_DIR)/usr/lib/erlang/releases/RELEASES

	# Get rid of windows cruft
	find $(INSTALL_DIR) -name *.bat -exec rm -v {} \;

	# Fix permissions
	cp $(INSTALL_DIR)/usr/lib/erlang/erts-$(VSN)/bin/start_erl.src \
	   $(INSTALL_DIR)/usr/lib/erlang/erts-$(VSN)/bin/start_erl
	chmod 755 $(INSTALL_DIR)/usr/lib/erlang/erts-$(VSN)/bin/start_erl
	chmod 755 $(INSTALL_DIR)/usr/lib/erlang/erts-$(VSN)/bin/*.src
	chmod 644 $(INSTALL_DIR)/usr/lib/erlang/bin/start.script
	chmod 644 $(INSTALL_DIR)/usr/lib/erlang/lib/wx-*/examples/*/*.beam

	# Remove some files which should be rather in erlang-doc-html package
	find $(INSTALL_DIR)/usr/lib/erlang/lib -name info -exec rm -v {} \;
	rm -rv $(INSTALL_DIR)/usr/lib/erlang/erts-$(VSN)/doc

	# Remove useless Install and manpage formatting scripts
	rm -v $(INSTALL_DIR)/usr/lib/erlang/Install
	rm -rv $(INSTALL_DIR)/usr/lib/erlang/misc

	# Install systemd units for epmd
	if [ "$(USE_CLOCK_GETTIME)" = "yes" ] ; then \
	    install -m 755 -d $(INSTALL_DIR)/usr/lib/systemd/system ; \
	    install -m 644 debian/epmd.service $(INSTALL_DIR)/usr/lib/systemd/system ; \
